package megacycles;

public class Vector {
  public double[] vector = { 0, 0, 0, 1 };

  public Vector() {
  }

  public Vector(double x, double y, double z) {
    vector[0] = x;
    vector[1] = y;
    vector[2] = z;
  }

  public double dot(Vector v) {
    return vector[0] * v.vector[0] + vector[1] * v.vector[1]
        + vector[2] * v.vector[2];
  }

  public void copyTo(Vector vector) {
    for(int i = 0; i < 4; i++) {
      vector.vector[i] = this.vector[i];
    }
  }

  public void copyFrom(Vector vector) {
    for(int i = 0; i < 4; i++) {
      this.vector[i] = vector.vector[i];
    }
  }

  public void subtractVector(Vector vector) {
    for(int i = 0; i < 3; i++) {
      this.vector[i] -= vector.vector[i];
    }
  }

  public void addVector(Vector vector) {
    for(int i = 0; i < 3; i++) {
      this.vector[i] += vector.vector[i];
    }
  }

  public void normalize() {
    double mag = Math.sqrt(vector[0] * vector[0] + vector[1] * vector[1]
        + vector[2] * vector[2]);
    for(int i = 0; i < 3; i++) {
      vector[i] /= mag;
    }
  }

  public double getX() {
    return vector[0];
  }

  public double getY() {
    return vector[1];
  }

  public double getZ() {
    return vector[2];
  }

  public void setX(double x) {
    vector[0] = x;
  }

  public void setY(double y) {
    vector[1] = y;
  }

  public void setZ(double z) {
    vector[2] = z;
  }

  public void scale(double s) {
    for(int i = 0; i < 3; i++) {
      vector[i] *= s;
    }
  }

  public Vector multiply(double s) {
    Vector vec = new Vector();
    double[] result = vec.vector;
    for(int i = 0; i < 3; i++) {
      result[i] = vector[i] * s;
    }
    return vec;
  }

  public Vector add(Vector b) {
    Vector vec = new Vector();
    double[] vectorB = b.vector;
    double[] result = vec.vector;
    for(int i = 0; i < 3; i++) {
      result[i] = vector[i] + vectorB[i];
    }
    return vec;
  }

  public Vector subtract(Vector b) {
    Vector vec = new Vector();
    double[] vectorB = b.vector;
    double[] result = vec.vector;
    for(int i = 0; i < 3; i++) {
      result[i] = vector[i] - vectorB[i];
    }
    return vec;
  }

  public static double distance2(Vector v1, Vector v2) {
    double dx = v1.getX() - v2.getX();
    double dy = v1.getY() - v2.getY();
    double dz = v1.getZ() - v2.getZ();
    return dx * dx + dy * dy + dz * dz;
  }

  public static double distance(Vector v1, Vector v2) {
    return Math.sqrt(distance2(v1, v2));
  }

  @Override
  public String toString() {
    return "[" + vector[0] + " " + vector[1] + " " + vector[2] + "]";
  }
}
